Coin: SoVRMLParent Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
SoVRMLParent Class Reference

The SoVRMLParent node is a superclass for all VRML grouping nodes. More...

`#include <Inventor/VRMLnodes/SoVRMLParent.h>`

Inheritance diagram for SoVRMLParent:

## Public Member Functions
virtual SoType | getTypeId (void) const
virtual SbBool | affectsState (void) const
virtual void | addChild (SoNode *child)
virtual void | insertChild (SoNode *child, int idx)
virtual SoNode * | getChild (int idx) const
virtual int | findChild (const SoNode *child) const
virtual int | getNumChildren (void) const
virtual void | removeChild (int idx)
virtual void | removeChild (SoNode *child)
virtual void | removeAllChildren (void)
virtual void | replaceChild (int idx, SoNode *child)
virtual void | replaceChild (SoNode *old, SoNode *child)
virtual SoChildList * | getChildren (void) const
virtual void | doAction (SoAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoGroup
| SoGroup (void)
| SoGroup (int nchildren)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | updateChildList (const SoNode *const *nodes, const int numnodes, SoChildList &cl)
static void | updateChildList (SoNode *nodewithsfnode, SoChildList &cl)
Static Public Member Functions inherited from SoGroup
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoMFNode | children
Public Attributes inherited from SoBase

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
| SoVRMLParent (void)
| SoVRMLParent (int approxchildren)
virtual | ~SoVRMLParent ()
virtual void | notify (SoNotList *list)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyConn)
Protected Member Functions inherited from SoGroup
virtual | ~SoGroup ()
virtual SbBool | readChildren (SoInput *in)
virtual SoNotRec | createNotRec (void)
void | setOperation (const SoNotRec::OperationType opType=SoNotRec::UNSPECIFIED, const SoNode *cc=NULL, const SoNode *pc=NULL, const int ci=-1)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes
SoMFNode | addChildren
SoMFNode | removeChildren
Protected Attributes inherited from SoGroup
SoChildList * | children
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoVRMLParent node is a superclass for all VRML grouping nodes.

## Constructor & Destructor Documentation

## ◆ SoVRMLParent() [1/2]

SoVRMLParent::SoVRMLParent | ( | void |  | ) |
| protected

Constructor.

## ◆ SoVRMLParent() [2/2]

SoVRMLParent::SoVRMLParent | ( | int | numchildren | ) |
| protected

Destructor. numchildren is the expected number of children.

## ◆ ~SoVRMLParent()

SoVRMLParent::~SoVRMLParent | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoVRMLParent::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoVRMLParent::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoGroup.

Reimplemented in SoVRMLAnchor, SoVRMLBillboard, SoVRMLCollision, SoVRMLGroup, and SoVRMLTransform.

## ◆ getFieldDataPtr()

const SoFieldData ** SoVRMLParent::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoVRMLParent::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoGroup.

Reimplemented in SoVRMLAnchor, SoVRMLBillboard, SoVRMLCollision, SoVRMLGroup, and SoVRMLTransform.

## ◆ initClass()

void SoVRMLParent::initClass | ( | void |  | ) |
| static

## ◆ affectsState()

SbBool SoVRMLParent::affectsState | ( | void |  | ) | const
| virtual

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented from SoNode.

## ◆ addChild()

void SoVRMLParent::addChild | ( | SoNode * | node | ) |
| virtual

Append a child node to the list of children nodes this group node is managing.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ insertChild()

void SoVRMLParent::insertChild | ( | SoNode * | child,
|  | int | newchildindex )
| virtual

Insert a child node at position newchildindex.

newchildindex must be <= this->getNumChildren()

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ getChild()

SoNode * SoVRMLParent::getChild | ( | int | index | ) | const
| virtual

Returns pointer to child node at index.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ findChild()

int SoVRMLParent::findChild | ( | const SoNode * | node | ) | const
| virtual

Returns index in our list of children for child node, or -1 if node is not a child of this group node.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ getNumChildren()

int SoVRMLParent::getNumChildren | ( | void |  | ) | const
| virtual

Returns number of child nodes managed by this group.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ removeChild() [1/2]

void SoVRMLParent::removeChild | ( | int | childindex | ) |
| virtual

Remove node at childindex in our list of children.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ removeChild() [2/2]

void SoVRMLParent::removeChild | ( | SoNode * | child | ) |
| virtual

Remove child from the set of children managed by this group node. Will decrease the reference count of child by 1.

This is a convenience method. It will simply call findChild() with child as argument, and then call removeChild(int) if the child is found.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ removeAllChildren()

void SoVRMLParent::removeAllChildren | ( | void |  | ) |
| virtual

Do not manage the children anymore. Will dereference all children by 1 as they are removed.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ replaceChild() [1/2]

void SoVRMLParent::replaceChild | ( | int | index,
|  | SoNode * | newchild )
| virtual

Replace child at index with newChild.

Dereferences the child previously at index, and increases the reference count of newChild by 1.

index must be < this->getNumChildren()

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ replaceChild() [2/2]

void SoVRMLParent::replaceChild | ( | SoNode * | oldchild,
|  | SoNode * | newchild )
| virtual

Replace oldchild with newchild.

Dereferences oldchild by 1, and increases the reference count of newchild by 1.

This is a convenience method. It will simply call findChild() with oldchild as argument, and call replaceChild(int, SoNode*) if the child is found.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

## ◆ getChildren()

SoChildList * SoVRMLParent::getChildren | ( | void |  | ) | const
| virtual

Returns list of children.

Reimplemented from SoGroup.

## ◆ doAction()

void SoVRMLParent::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoGroup.

Reimplemented in SoVRMLBillboard, SoVRMLGroup, and SoVRMLTransform.

## ◆ search()

void SoVRMLParent::search | ( | SoSearchAction * | action | ) |
| virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
  SoSearchAction

Reimplemented from SoGroup.

Reimplemented in SoVRMLBillboard, and SoVRMLGroup.

## ◆ write()

void SoVRMLParent::write | ( | SoWriteAction * | action | ) |
| virtual

Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoGroup.

Reimplemented in SoVRMLGroup.

## ◆ getPrimitiveCount()

void SoVRMLParent::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoGroup.

Reimplemented in SoVRMLGroup, and SoVRMLTransform.

## ◆ updateChildList() [1/2]

void SoVRMLParent::updateChildList | ( | const SoNode *const * | nodes,
|  | const int | numnodes,
|  | SoChildList & | cl )
| static

A convenience method that can be used to update cl to match the list of nodes in nodes.

## ◆ updateChildList() [2/2]

void SoVRMLParent::updateChildList | ( | SoNode * | nodewithsfnode,
|  | SoChildList & | cl )
| static

A convenience method that is used to sync the nodes in cl with all nodes in SoSFNode fields in nodewithsfnode.

## ◆ notify()

void SoVRMLParent::notify | ( | SoNotList * | l | ) |
| protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Reimplemented in SoVRMLBillboard, SoVRMLCollision, SoVRMLGroup, and SoVRMLTransform.

## ◆ readInstance()

SbBool SoVRMLParent::readInstance | ( | SoInput * | in,
|  | unsigned short | flags )
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoGroup.

## ◆ copyContents()

void SoVRMLParent::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections )
| protectedvirtual

Makes a deep copy of all data of from into this instance, except external scene graph references if copyconnections is `FALSE`.

This is the method that should be overridden by extension node / engine / dragger / whatever subclasses which need to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();
SoNode
The SoNode class is the base class for nodes used in scene graphs.
Definition SoNode.h:56
SoNode::copy
virtual SoNode * copy(SbBool copyconnections=FALSE) const
Definition SoNode.cpp:474

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to its parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc.)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}
SoFieldContainer
The SoFieldContainer class is a base class for all classes that contain fields.
Definition SoFieldContainer.h:43
SoNode::copyContents
virtual void copyContents(const SoFieldContainer *from, SbBool copyconnections)
Definition SoNode.cpp:1483

Reimplemented from SoGroup.

## Member Data Documentation

## ◆ children

SoMFNode SoVRMLParent::children

The children nodes.

## ◆ addChildren

SoMFNode SoVRMLParent::addChildren
| protected

An eventIn that is used to add children to this node.

## ◆ removeChildren

SoMFNode SoVRMLParent::removeChildren
| protected

An eventIn that is used to remove children from this node.

The documentation for this class was generated from the following files:

- SoVRMLParent.h
- Parent.cpp